# redis-swift

Session storage
===============

### Installation
```sh
$ npm install redis-swift
```

Usage
=====

Create connection
-----------------

### Start redis service

![08-03-2017 11-46-11](https://cloud.githubusercontent.com/assets/22218672/23693914/cd35adba-03f8-11e7-8504-6ac347f68d87.jpg)

```javascript

    var RedisSwift = require('../build');
    var options = {
        port: 6379,
        host: '127.0.0.1',
        collection:[
            'sessions',
            //'devices'
        ]
    };
    
    var memory = new RedisSwift(options);
    
    var user = {
        id: '545e1cae5ae582d1b4639',
        login: 'expamle',
        password: 'password'
    };    
```

Writing item to Memory [ Firts-step ]
-------------------------------------

```javascript

    async function write(key, value, expire) {
        try {
            return await memory.sessions.write(key, value, expire);
        }
        catch (error) {
            throw error
        }
    }
    
    setTimeout(async(user) => {
        var oneday = 24 * 60 * 60;
        var key = user.id;
    
        var result = await write(key, user, oneday);
        
        console.log("Writing => " , result);
        
    }, 3000, user);
```

### Result

![08-03-2017 12-11-00](https://cloud.githubusercontent.com/assets/22218672/23693854/772860de-03f8-11e7-9a8a-dce81243122f.jpg)

Read item in memory [ Second-step ]
-----------------------------------

```javascript

    async function read(key) {
        try {
            return await memory.sessions.read(key);
        }
        catch (error) {
            throw error;
        }
    }
    
    setTimeout(async(key) => {
    
        var result = await read(key)
    
        console.log("Reading => ", result);
    
    }, 6000, user.id);

```
### Result

![08-03-2017 11-54-18](https://cloud.githubusercontent.com/assets/22218672/23693899/bbdd52fc-03f8-11e7-9b4d-5ab69bcd5683.jpg)


Delete item in memory [ Third-step ]
------------------------------------

```javascript

async function deleting(key) {
    try {
        return await memory.sessions.delete(key);
    }
    catch (error) {
        throw error;
    }
}

setTimeout(async(key) => {

    var result = await deleting(key);
    
    console.log("Deleting => " , result);

}, 9000, user.id)
```

###Result

![08-03-2017 12-11-19](https://cloud.githubusercontent.com/assets/22218672/23693940/f5b118b0-03f8-11e7-823c-1ca8a053b6aa.jpg)


##Logs

![08-03-2017 12-27-28](https://cloud.githubusercontent.com/assets/22218672/23694259/a2a0ca9c-03fa-11e7-843c-304a15c5fb4b.jpg)