var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _redis = require('redis');

var Redis = _interopRequireWildcard(_redis);

var RedisConnect = (function () {
    function RedisConnect(options) {
        _classCallCheck(this, RedisConnect);

        this.onInit(options);
    }

    _createClass(RedisConnect, [{
        key: 'onInit',
        value: function onInit(options) {
            var _this = this;

            options = this.prepareOptions(options);
            this.client = Redis.createClient(options.port, options.host, {});
            this.client.select(options.db, function () {});

            options.collections.forEach(function (collection) {
                _this[collection] = new RedisMethods(_this.client, collection);
            });
        }
    }, {
        key: 'prepareOptions',
        value: function prepareOptions(options) {
            if (!options) options = {};
            if (!options.db) options.db = 0;
            if (!options.port) options.port = 6379;
            if (!options.host) options.host = '127.0.0.1';
            if (!options.collections) options.collections = ['sessions'];
            return options;
        }
    }]);

    return RedisConnect;
})();

exports['default'] = RedisConnect;

var RedisMethods = (function () {
    function RedisMethods(client, collection) {
        _classCallCheck(this, RedisMethods);

        this.client = client;
        this.collection = collection;
    }

    _createClass(RedisMethods, [{
        key: 'write',
        value: function write(key, value, expire) {
            var _this2 = this;

            if (!key || !value || !expire) {
                throw new Error('Invalid request params.');
            }

            key = this.collection + ':' + key;

            return new _Promise(function (resolve, reject) {
                try {
                    value = JSON.stringify(value);
                    _this2.client.setex(key, expire, value, function (error, result) {
                        if (error) {
                            return reject(error);
                        }
                        resolve({ succes: true });
                    });
                } catch (error) {
                    return reject(error);
                }
            });
        }
    }, {
        key: 'read',
        value: function read(key) {
            var _this3 = this;

            if (!key) {
                throw new Error('Invalid request params.');
            }
            key = this.collection + ':' + key;

            return new _Promise(function (resolve, reject) {
                _this3.client.get(key, function (error, result) {
                    if (error) return reject(error);
                    try {
                        result = JSON.parse(result);
                    } catch (error) {
                        return reject(error);
                    }
                    resolve(result);
                });
            });
        }
    }, {
        key: 'delete',
        value: function _delete(key) {
            var _this4 = this;

            if (!key) {
                throw new Error('Invalid request params.');
            }
            key = this.collection + ':' + key;

            return new _Promise(function (resolve, reject) {
                _this4.client.del(key, function (error) {
                    if (error) {
                        return reject(error);
                    }
                    resolve({ succes: true });
                });
            });
        }
    }]);

    return RedisMethods;
})();

module.exports = exports['default'];
//# sourceMappingURL=index.js.map
